//@author: vux
//@help: template for standard shaders
//@tags: template
//@credits: 

Texture2D texture2d <string uiname="Texture";>;

SamplerState linearSampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};
 
cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : LAYERVIEWPROJECTION;	
};

cbuffer cbPerObj : register( b1 )
{
	int offset;
	float4x4 tW : WORLD;
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
};

StructuredBuffer<float3> sbPosition;
StructuredBuffer<float2> sbTexCord;

struct VS_IN
{
	uint vid : SV_VertexID;
	uint iid : SV_InstanceID;
};

struct vs2ps
{
    float4 PosWVP: SV_Position;
    float4 TexCd: TEXCOORD0;
};

vs2ps VS(VS_IN input)
{
    float4 pos;
	pos.xyz = sbPosition[input.vid + offset].xyz;
	pos.w = 1.0f;
	float4 uv;
	uv.xy = sbTexCord[input.vid + offset].xy;
	uv.zw = 0.0f, 0.0f;
	
	vs2ps output;
	output.PosWVP  = mul(pos,mul(tW,tVP));
    output.TexCd = uv;
    return output;
}




float4 PS(vs2ps In): SV_Target
{
    float4 col = texture2d.Sample(linearSampler,In.TexCd.xy) * cAmb;
    return col;
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




